Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes

# EggGroup Class Reference

The main glue of the egg hierarchy, this corresponds to the <Group>, <Instance>, and <Joint> type nodes. More...

Inheritance diagram for EggGroup:

List of all members.

## Public Types
enum | BillboardType { BTNone = 0, BTAxis = 32, BTPointCameraRelative = 64, BTPointWorldRelative = 128 }
enum | BlendMode { BMUnspecified = 0, BMNone = 1, BMAdd = 2, BMSubtract = 3, BMInvSubtract = 4, BMMin = 5, BMMax = 6 }
enum | BlendOperand { BOUnspecified = 0, BOZero = 1, BOOne = 2, BOIncomingColor = 3, BOOneMinusIncomingColor = 4, BOFbufferColor = 5, BOOneMinusFbufferColor = 6, BOIncomingAlpha = 7, BOOneMinusIncomingAlpha = 8, BOFbufferAlpha = 9, BOOneMinusFbufferAlpha = 10, BOConstantColor = 11, BOOneMinusConstantColor = 12, BOConstantAlpha = 13, BOOneMinusConstantAlpha = 14, BOIncomingColorSaturate = 15, BOColorScale = 16, BOOneMinusColorScale = 17, BOAlphaScale = 18, BOOneMinusAlphaScale = 19 }
enum | CollideFlags { CFNone = 0, CFDescend = 1048576, CFEvent = 2097152, CFKeep = 4194304, CFSolid = 8388608, CFCenter = 16777216, CFTurnstile = 33554432, CFLevel = 67108864, CFIntangible = 134217728 }
enum | CollisionSolidType { CSTNone = 0, CSTPlane = 65536, CSTPolygon = 131072, CSTPolyset = 196608, CSTSphere = 262144, CSTTube = 327680, CSTInvSphere = 393216, CSTFloorMesh = 524288 }
enum | DartType { DTNone = 0, DTStructured = 268435456, DTSync = 536870912, DTNosync = 805306368, DTDefault = 1073741824 }
enum | DCSType { DCUnspecified = 0, DCNone = 16, DCLocal = 32, DCNet = 48, DCNoTouch = 64, DCDefault = 80 }
enum | GroupType { GTInvalid = -1, GTGroup = 0, GTInstance = 1, GTJoint = 2 }
## Public Member Functions
| EggGroup (EggGroup const copy)
| EggGroup (string name)
| EggGroup ()
| addGroupRef (EggGroup group)
| Adds a new <Ref> entry to the group.
| addObjectType (string object_type)
| clearBillboardCenter ()
| clearBlendColor ()
| Removes the blend color specification.
| clearCollideMask ()
| clearCollisionName ()
| clearDefaultPose ()
| Removes the initial pose transform.
| clearFromCollideMask ()
| clearGroupRefs ()
| Removes all of the <Ref> entries within this group.
| clearIndexedFlag ()
| clearIntoCollideMask ()
| clearLod ()
| clearObjectTypes ()
| clearTag (string key)
| Removes the value defined for this key on this particular node.
EggRenderMode | determineAlphaMode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has an alpha_mode other than AM_unspecified.
EggRenderMode | determineBin ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a bin specified.
bool | determineDecal ()
| Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "decal" flag set.
EggRenderMode | determineDepthOffset ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a depth_offset specified.
EggRenderMode | determineDepthTestMode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a depth_test_mode other than DTM_unspecified.
EggRenderMode | determineDepthWriteMode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a depth_write_mode other than DWM_unspecified.
EggRenderMode | determineDrawOrder ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a draw_order specified.
bool | determineIndexed ()
| Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "indexed" scalar set.
EggRenderMode | determineVisibilityMode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a visibility_mode other than VM_unspecified.
Point3D const | getBillboardCenter ()
BillboardType | getBillboardType ()
VBase4 const | getBlendColor ()
| Returns the blend color if one has been specified, or (0, 0, 0, 0) if one has not.
BlendMode | getBlendMode ()
BlendOperand | getBlendOperandA ()
BlendOperand | getBlendOperandB ()
CollideFlags | getCollideFlags ()
BitMaskunsigned | getCollideMask ()
string | getCollisionName ()
CollisionSolidType | getCsType ()
DartType | getDartType ()
DCSType | getDcsType ()
bool | getDecalFlag ()
EggTransform const | getDefaultPose ()
| Returns a read-only accessor to the initial pose transform.
bool | getDirectFlag ()
BitMaskunsigned | getFromCollideMask ()
EggGroup | getGroupRef (int n)
| Returns the nth <Ref> entry within this group.
list | getGroupRefs ()
GroupType | getGroupType ()
bool | getIndexedFlag ()
BitMaskunsigned | getIntoCollideMask ()
EggSwitchCondition const | getLod ()
bool | getModelFlag ()
bool | getNofogFlag ()
int | getNumGroupRefs ()
| Returns the number of <Ref> entries within this group.
int | getNumObjectTypes ()
string | getObjectType (int index)
list | getObjectTypes ()
bool | getOccluderFlag ()
bool | getPolylightFlag ()
bool | getPortalFlag ()
double | getScrollR ()
double | getScrollU ()
double | getScrollV ()
bool | getSwitchFlag ()
double | getSwitchFps ()
string | getTag (string key)
| Retrieves the user-defined value that was previously set on this node for the particular key, if any.
bool | getTexlistFlag ()
double | getVertexMembership (EggVertex const vert)
| Returns the amount of membership of the indicated vertex in this group.
bool | hasBillboardCenter ()
bool | hasBlendColor ()
| Returns true if the blend color has been specified, false otherwise.
bool | hasCollideMask ()
bool | hasCollisionName ()
bool | hasDcsType ()
| Returns true if the specified DCS type is not DC_none and not DC_unspecified.
bool | hasFromCollideMask ()
bool | hasIndexedFlag ()
bool | hasIntoCollideMask ()
bool | hasLod ()
bool | hasObjectType (string object_type)
| Returns true if the indicated object type has been added to the group, or false otherwise.
bool | hasScrollingUvs ()
bool | hasTag (string key)
| Returns true if a value has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.
bool | isInstanceType ()
| Returns true if this group is an instance type node; i.e.
bool | isJoint ()
| Returns true if this particular node represents a <Joint> entry or not.
EggTransform | modifyDefaultPose ()
| Returns a writable accessor to the initial pose transform.
EggGroup | operator= (EggGroup const copy)
| refVertex (EggVertex vert, double membership)
| Adds the vertex to the set of those referenced by the group, at the indicated membership level.
| refVertex (EggVertex vert)
| Adds the vertex to the set of those referenced by the group, at the indicated membership level.
| removeGroupRef (int n)
| Removes the nth <Ref> entry within this group.
bool | removeObjectType (string object_type)
| Removes the first instance of the indicated object type from the group if it is present.
| setBillboardCenter (Point3D const billboard_center)
| Sets the point around which the billboard will rotate, if this node contains a billboard specification.
| setBillboardType (BillboardType type)
| setBlendColor (VBase4 const blend_color)
| setBlendMode (BlendMode blend_mode)
| setBlendOperandA (BlendOperand blend_operand_a)
| setBlendOperandB (BlendOperand blend_operand_b)
| setCollideFlags (int flags)
| setCollideMask (BitMaskunsigned int, 32 mask)
| setCollisionName (string collision_name)
| setCsType (CollisionSolidType type)
| setDartType (DartType type)
| setDcsType (DCSType type)
| setDecalFlag (bool flag)
| setDefaultPose (EggTransform const transform)
| Replaces the initial pose transform.
| setDirectFlag (bool flag)
| setFromCollideMask (BitMaskunsigned int, 32 mask)
| setGroupType (GroupType type)
| setIndexedFlag (bool flag)
| If this flag is true, geometry at this node and below will be generated as indexed geometry.
| setIntoCollideMask (BitMaskunsigned int, 32 mask)
| setLod (EggSwitchCondition const lod)
| setModelFlag (bool flag)
| setNofogFlag (bool flag)
| setOccluderFlag (bool flag)
| setPolylightFlag (bool flag)
| setPortalFlag (bool flag)
| setScrollR (double r_speed)
| setScrollU (double u_speed)
| setScrollV (double v_speed)
| setSwitchFlag (bool flag)
| setSwitchFps (double fps)
| setTag (string key, string value)
| Associates a user-defined value with a user-defined key which is stored on the node.
| setTexlistFlag (bool flag)
| setVertexMembership (EggVertex vert, double membership)
| Explicitly sets the net membership of the indicated vertex in this group to the given value.
| stealVrefs (EggGroup other)
| Moves all of the vertex references from the indicated other group into this one.
| testVrefIntegrity ()
| unrefAllVertices ()
| Removes all vertices from the reference list.
| unrefVertex (EggVertex vert)
| Removes the vertex from the set of those referenced by the group.
| write (ostream out, int indent_level)
| Writes the group and all of its children to the indicated output stream in Egg format.
| writeBillboardFlags (ostream out, int indent_level)
| Writes just the <Billboard> entry and related fields to the indicated ostream.
| writeCollideFlags (ostream out, int indent_level)
| Writes just the <Collide> entry and related fields to the indicated ostream.
| writeDecalFlags (ostream out, int indent_level)
| Writes the flags related to decaling, if any.
| writeModelFlags (ostream out, int indent_level)
| Writes the <Model> flag and related flags to the indicated ostream.
| writeObjectTypes (ostream out, int indent_level)
| Writes just the <ObjectTypes> entries, if any, to the indicated ostream.
| writeRenderMode (ostream out, int indent_level)
| Writes the flags inherited from EggRenderMode and similar flags that control obscure render effects.
| writeSwitchFlags (ostream out, int indent_level)
| Writes the <Switch> flag and related flags to the indicated ostream.
| writeTags (ostream out, int indent_level)
| Writes just the <Tag> entries, if any, to the indicated ostream.
## Static Public Member Functions
static TypeHandle | getClassType ()
static BillboardType | stringBillboardType (string strval)
| Returns the BillboardType value associated with the given string representation, or BT_none if the string does not match any known BillboardType value.
static BlendMode | stringBlendMode (string strval)
| Returns the BlendMode value associated with the given string representation, or BM_none if the string does not match any known BlendMode.
static BlendOperand | stringBlendOperand (string strval)
| Returns the BlendOperand value associated with the given string representation, or BO_none if the string does not match any known BlendOperand.
static CollideFlags | stringCollideFlags (string strval)
| Returns the CollideFlags value associated with the given string representation, or CF_none if the string does not match any known CollideFlags value.
static CollisionSolidType | stringCsType (string strval)
| Returns the CollisionSolidType value associated with the given string representation, or CST_none if the string does not match any known CollisionSolidType value.
static DartType | stringDartType (string strval)
| Returns the DartType value associated with the given string representation, or DT_none if the string does not match any known DartType value.
static DCSType | stringDcsType (string strval)
| Returns the DCSType value associated with the given string representation, or DC_unspecified if the string does not match any known DCSType value.
static GroupType | stringGroupType (string strval)
| Returns the GroupType value associated with the given string representation, or GT_invalid if the string does not match any known GroupType value.
## Public Attributes
BitMaskunsigned | int

## Detailed Description

The main glue of the egg hierarchy, this corresponds to the <Group>, <Instance>, and <Joint> type nodes.

## Member Enumeration Documentation

enum BillboardType

Enumerator:

  BTNone |
  BTAxis |
  BTPointCameraRelative |
  BTPointWorldRelative |

enum BlendMode

Enumerator:

  BMUnspecified |
  BMNone |
  BMAdd |
  BMSubtract |
  BMInvSubtract |
  BMMin |
  BMMax |

enum BlendOperand

Enumerator:

  BOUnspecified |
  BOZero |
  BOOne |
  BOIncomingColor |
  BOOneMinusIncomingColor |
  BOFbufferColor |
  BOOneMinusFbufferColor |
  BOIncomingAlpha |
  BOOneMinusIncomingAlpha |
  BOFbufferAlpha |
  BOOneMinusFbufferAlpha |
  BOConstantColor |
  BOOneMinusConstantColor |
  BOConstantAlpha |
  BOOneMinusConstantAlpha |
  BOIncomingColorSaturate |
  BOColorScale |
  BOOneMinusColorScale |
  BOAlphaScale |
  BOOneMinusAlphaScale |

enum CollideFlags

Enumerator:

  CFNone |
  CFDescend |
  CFEvent |
  CFKeep |
  CFSolid |
  CFCenter |
  CFTurnstile |
  CFLevel |
  CFIntangible |

enum CollisionSolidType

Enumerator:

  CSTNone |
  CSTPlane |
  CSTPolygon |
  CSTPolyset |
  CSTSphere |
  CSTTube |
  CSTInvSphere |
  CSTFloorMesh |

enum DartType

Enumerator:

  DTNone |
  DTStructured |
  DTSync |
  DTNosync |
  DTDefault |

enum DCSType

Enumerator:

  DCUnspecified |
  DCNone |
  DCLocal |
  DCNet |
  DCNoTouch |
  DCDefault |

enum GroupType

Enumerator:

  GTInvalid |
  GTGroup |
  GTInstance |
  GTJoint |

## Constructor & Destructor Documentation

EggGroup | ( | EggGroup const | copy | ) |

EggGroup | ( | string | name | ) |

EggGroup | ( |  | ) |

## Member Function Documentation

addGroupRef | ( | EggGroup | group | ) |

Adds a new <Ref> entry to the group.

This declares an internal reference to another node, and is used to implement scene-graph instancing; it is only valid if the group_type is GT_instance.

addObjectType | ( | string | object_type | ) |

clearBillboardCenter | ( |  | ) |

clearBlendColor | ( |  | ) |

Removes the blend color specification.

clearCollideMask | ( |  | ) |

clearCollisionName | ( |  | ) |

clearDefaultPose | ( |  | ) |

Removes the initial pose transform.

See set_default_pose().

clearFromCollideMask | ( |  | ) |

clearGroupRefs | ( |  | ) |

Removes all of the <Ref> entries within this group.

See add_group_ref().

clearIndexedFlag | ( |  | ) |

clearIntoCollideMask | ( |  | ) |

clearLod | ( |  | ) |

clearObjectTypes | ( |  | ) |

clearTag | ( | string | key | ) |

Removes the value defined for this key on this particular node.

After a call to clear_tag(), has_tag() will return false for the indicated key.

EggRenderMode determineAlphaMode | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has an alpha_mode other than AM_unspecified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented from EggNode.

EggRenderMode determineBin | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a bin specified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented from EggNode.

bool determineDecal | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "decal" flag set.

Returns the value of the decal flag if it is found, or false if it is not.

In other words, returns true if the "decal" flag is in effect for the indicated node, false otherwise.

Reimplemented from EggNode.

EggRenderMode determineDepthOffset | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a depth_offset specified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented from EggNode.

EggRenderMode determineDepthTestMode | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a depth_test_mode other than DTM_unspecified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented from EggNode.

EggRenderMode determineDepthWriteMode | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a depth_write_mode other than DWM_unspecified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented from EggNode.

EggRenderMode determineDrawOrder | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a draw_order specified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented from EggNode.

bool determineIndexed | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "indexed" scalar set.

Returns the value of the indexed scalar if it is found, or false if it is not.

In other words, returns true if the "indexed" flag is in effect for the indicated node, false otherwise.

Reimplemented from EggNode.

EggRenderMode determineVisibilityMode | ( |  | ) |

Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this group that has a visibility_mode other than VM_unspecified.

Returns a valid EggRenderMode pointer if one is found, or NULL otherwise.

Reimplemented from EggNode.

Point3D const getBillboardCenter | ( |  | ) |

BillboardType getBillboardType | ( |  | ) |

VBase4 const getBlendColor | ( |  | ) |

Returns the blend color if one has been specified, or (0, 0, 0, 0) if one has not.

BlendMode getBlendMode | ( |  | ) |

BlendOperand getBlendOperandA | ( |  | ) |

BlendOperand getBlendOperandB | ( |  | ) |

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from EggGroupNode.

Reimplemented in EggBin.

CollideFlags getCollideFlags | ( |  | ) |

BitMaskunsigned getCollideMask | ( |  | ) |

string getCollisionName | ( |  | ) |

CollisionSolidType getCsType | ( |  | ) |

DartType getDartType | ( |  | ) |

DCSType getDcsType | ( |  | ) |

bool getDecalFlag | ( |  | ) |

EggTransform const getDefaultPose | ( |  | ) |

Returns a read-only accessor to the initial pose transform.

This is the <DefaultPose> entry for a Joint, and defines only the initial transform pose for the unanimated joint; it has nothing to do with the group's <Transform> entry, which defines the (eventual) space of the group's vertices.

bool getDirectFlag | ( |  | ) |

BitMaskunsigned getFromCollideMask | ( |  | ) |

EggGroup getGroupRef | ( | int | n | ) |

Returns the nth <Ref> entry within this group.

See add_group_ref().

list getGroupRefs | ( |  | ) |

GroupType getGroupType | ( |  | ) |

bool getIndexedFlag | ( |  | ) |

BitMaskunsigned getIntoCollideMask | ( |  | ) |

EggSwitchCondition const getLod | ( |  | ) |

bool getModelFlag | ( |  | ) |

bool getNofogFlag | ( |  | ) |

int getNumGroupRefs | ( |  | ) |

Returns the number of <Ref> entries within this group.

See add_group_ref().

int getNumObjectTypes | ( |  | ) |

string getObjectType | ( | int | index | ) |

list getObjectTypes | ( |  | ) |

bool getOccluderFlag | ( |  | ) |

bool getPolylightFlag | ( |  | ) |

bool getPortalFlag | ( |  | ) |

double getScrollR | ( |  | ) |

double getScrollU | ( |  | ) |

double getScrollV | ( |  | ) |

bool getSwitchFlag | ( |  | ) |

double getSwitchFps | ( |  | ) |

string getTag | ( | string | key | ) |

Retrieves the user-defined value that was previously set on this node for the particular key, if any.

If no value has been previously set, returns the empty string.

bool getTexlistFlag | ( |  | ) |

double getVertexMembership | ( | EggVertex const | vert | ) |

Returns the amount of membership of the indicated vertex in this group.

If the vertex is not reffed by the group, returns 0.

bool hasBillboardCenter | ( |  | ) |

bool hasBlendColor | ( |  | ) |

Returns true if the blend color has been specified, false otherwise.

bool hasCollideMask | ( |  | ) |

bool hasCollisionName | ( |  | ) |

bool hasDcsType | ( |  | ) |

Returns true if the specified DCS type is not DC_none and not DC_unspecified.

bool hasFromCollideMask | ( |  | ) |

bool hasIndexedFlag | ( |  | ) |

bool hasIntoCollideMask | ( |  | ) |

bool hasLod | ( |  | ) |

bool hasObjectType | ( | string | object_type | ) |

Returns true if the indicated object type has been added to the group, or false otherwise.

bool hasScrollingUvs | ( |  | ) |

bool hasTag | ( | string | key | ) |

Returns true if a value has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.

bool isInstanceType | ( |  | ) |

Returns true if this group is an instance type node; i.e.

it begins the root of a local coordinate space. This is not related to instancing (multiple copies of a node in a scene graph).

This also includes the case of the node including a billboard flag without an explicit center, which implicitly makes the node behave like an instance.

bool isJoint | ( |  | ) |

Returns true if this particular node represents a <Joint> entry or not.

This is a handy thing to know since Joints are sorted to the end of their sibling list when writing an egg file. See EggGroupNode.write().

Reimplemented from EggNode.

EggTransform modifyDefaultPose | ( |  | ) |

Returns a writable accessor to the initial pose transform.

This is the <DefaultPose> entry for a Joint, and defines only the initial transform pose for the unanimated joint; it has nothing to do with the group's <Transform> entry, which defines the (eventual) space of the group's vertices.

EggGroup operator= | ( | EggGroup const | copy | ) |

refVertex | ( | EggVertex | vert | ) |

Adds the vertex to the set of those referenced by the group, at the indicated membership level.

If the vertex is already being referenced, increases the membership amount by the indicated amount.

refVertex | ( | EggVertex | vert,
|  | double | membership
| ) |  |

Adds the vertex to the set of those referenced by the group, at the indicated membership level.

If the vertex is already being referenced, increases the membership amount by the indicated amount.

removeGroupRef | ( | int | n | ) |

Removes the nth <Ref> entry within this group.

See add_group_ref().

bool removeObjectType | ( | string | object_type | ) |

Removes the first instance of the indicated object type from the group if it is present.

Returns true if the object type was found and removed, false otherwise.

setBillboardCenter | ( | Point3D const | billboard_center | ) |

Sets the point around which the billboard will rotate, if this node contains a billboard specification.

If a billboard type is given but no billboard_center is specified, then the group node is treated as an <Instance>, and the billboard rotates around the origin. If, however, a billboard_center is specified, then the group node is *not* treated as an <Instance>, and the billboard rotates around the specified point.

The point is in the same coordinate system as the vertices of this node: usually global, but possibly local if there is an <Instance> somewhere above. Specifically, this is the coordinate system defined by get_vertex_frame().

setBillboardType | ( | BillboardType | type | ) |

setBlendColor | ( | VBase4 const | blend_color | ) |

setBlendMode | ( | BlendMode | blend_mode | ) |

setBlendOperandA | ( | BlendOperand | blend_operand_a | ) |

setBlendOperandB | ( | BlendOperand | blend_operand_b | ) |

setCollideFlags | ( | int | flags | ) |

setCollideMask | ( | BitMaskunsigned | int,
|  | 32 | mask
| ) |  |

setCollisionName | ( | string | collision_name | ) |

setCsType | ( | CollisionSolidType | type | ) |

setDartType | ( | DartType | type | ) |

setDcsType | ( | DCSType | type | ) |

setDecalFlag | ( | bool | flag | ) |

setDefaultPose | ( | EggTransform const | transform | ) |

Replaces the initial pose transform.

This is the <DefaultPose> entry for a Joint, and defines only the initial transform pose for the unanimated joint; it has nothing to do with the group's <Transform> entry, which defines the (eventual) space of the group's vertices.

setDirectFlag | ( | bool | flag | ) |

setFromCollideMask | ( | BitMaskunsigned | int,
|  | 32 | mask
| ) |  |

setGroupType | ( | GroupType | type | ) |

setIndexedFlag | ( | bool | flag | ) |

If this flag is true, geometry at this node and below will be generated as indexed geometry.

setIntoCollideMask | ( | BitMaskunsigned | int,
|  | 32 | mask
| ) |  |

setLod | ( | EggSwitchCondition const | lod | ) |

setModelFlag | ( | bool | flag | ) |

setNofogFlag | ( | bool | flag | ) |

setOccluderFlag | ( | bool | flag | ) |

setPolylightFlag | ( | bool | flag | ) |

setPortalFlag | ( | bool | flag | ) |

setScrollR | ( | double | r_speed | ) |

setScrollU | ( | double | u_speed | ) |

setScrollV | ( | double | v_speed | ) |

setSwitchFlag | ( | bool | flag | ) |

setSwitchFps | ( | double | fps | ) |

setTag | ( | string | key,
|  | string | value
| ) |  |

Associates a user-defined value with a user-defined key which is stored on the node.

This value has no meaning to Panda; but it is stored indefinitely on the node until it is requested again. This value will be copied to the PandaNode that is created for this particular EggGroup if the egg file is loaded as a scene.

Each unique key stores a different string value. There is no effective limit on the number of different keys that may be stored or on the length of any one key's value.

setTexlistFlag | ( | bool | flag | ) |

setVertexMembership | ( | EggVertex | vert,
|  | double | membership
| ) |  |

Explicitly sets the net membership of the indicated vertex in this group to the given value.

stealVrefs | ( | EggGroup | other | ) |

Moves all of the vertex references from the indicated other group into this one.

If a given vertex was previously shared by both groups, the relative memberships will be summed.

static BillboardType stringBillboardType | ( | string | strval | ) | `[static]`

Returns the BillboardType value associated with the given string representation, or BT_none if the string does not match any known BillboardType value.

static BlendMode stringBlendMode | ( | string | strval | ) | `[static]`

Returns the BlendMode value associated with the given string representation, or BM_none if the string does not match any known BlendMode.

static BlendOperand stringBlendOperand | ( | string | strval | ) | `[static]`

Returns the BlendOperand value associated with the given string representation, or BO_none if the string does not match any known BlendOperand.

static CollideFlags stringCollideFlags | ( | string | strval | ) | `[static]`

Returns the CollideFlags value associated with the given string representation, or CF_none if the string does not match any known CollideFlags value.

This only recognizes a single keyword; it does not attempt to parse a string of keywords.

static CollisionSolidType stringCsType | ( | string | strval | ) | `[static]`

Returns the CollisionSolidType value associated with the given string representation, or CST_none if the string does not match any known CollisionSolidType value.

static DartType stringDartType | ( | string | strval | ) | `[static]`

Returns the DartType value associated with the given string representation, or DT_none if the string does not match any known DartType value.

static DCSType stringDcsType | ( | string | strval | ) | `[static]`

Returns the DCSType value associated with the given string representation, or DC_unspecified if the string does not match any known DCSType value.

static GroupType stringGroupType | ( | string | strval | ) | `[static]`

Returns the GroupType value associated with the given string representation, or GT_invalid if the string does not match any known GroupType value.

testVrefIntegrity | ( |  | ) |

unrefAllVertices | ( |  | ) |

Removes all vertices from the reference list.

unrefVertex | ( | EggVertex | vert | ) |

Removes the vertex from the set of those referenced by the group.

Does nothing if the vertex is not already reffed.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes the group and all of its children to the indicated output stream in Egg format.

Reimplemented from EggRenderMode.

writeBillboardFlags | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes just the <Billboard> entry and related fields to the indicated ostream.

writeCollideFlags | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes just the <Collide> entry and related fields to the indicated ostream.

writeDecalFlags | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes the flags related to decaling, if any.

writeModelFlags | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes the <Model> flag and related flags to the indicated ostream.

writeObjectTypes | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes just the <ObjectTypes> entries, if any, to the indicated ostream.

writeRenderMode | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes the flags inherited from EggRenderMode and similar flags that control obscure render effects.

writeSwitchFlags | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes the <Switch> flag and related flags to the indicated ostream.

writeTags | ( | ostream | out,
|  | int | indent_level
| ) |  |

Writes just the <Tag> entries, if any, to the indicated ostream.

## Member Data Documentation

BitMaskunsigned int

All Classes Namespaces Functions Variables Enumerations Enumerator Properties